'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
'  Castle cannons        - by William Burns
'
'  Simple game of shooting a cannon with the correct angle and velocity, while adjusting
'  for the wind.
'
'  Converted to PB from a program I made 15+ years ago on a MC10 computer with only 4k of
'  memory.   No hard drive, not even a floppy drive. (I had to manually save programs to an
'  audio cassette recorder)  How's that for dating yourself....
'
'  Still is surprisingly fun.
'
'  Enjoy
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
#Dim All
#Compile Exe
#Include "WIN32API.INC"
Declare CallBack Function DlgCallBack()
%BACKGROUND    = 500
%TXTANGLE      = 505
%TXTVELOCITY   = 510
%IDALAB        = 515
%IDVLAB        = 520
%LABMSG        = 525
%LABWIND       = 530
%BUTRESTART    = 535
Global hDlg       As Dword
Global gGround()  As Long     'array stores the ground layout
Global gX1        As Long     'castle1 x position
Global gX2        As Long     'castle2 x position
Global gWind      As Long     'wind speed and direction
Global gShots()   As String   'track prev shots
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
Function PBMain
   Dialog New 0, "Castle Cannons",,, 420, 250, %ws_caption Or %ws_clipchildren Or %ws_sysmenu Or %ws_minimizebox Or %ws_maximizebox Or %ws_thickframe To hDlg
   Dialog Set Color hDlg, -1&, RGB(50,20,150)
   Control Add Label, hDlg, %IDALAB, "Angle:",1,210,20,10
   Control Set Color hDlg, %IDALAB, %white, RGB(50,20,150)
   Control Add TextBox, hDlg, %TXTANGLE, "",40,210,20,12
   Control Add Label, hDlg, %IDVLAB, "Velocity:",1,230,28,10
   Control Set Color hDlg, %IDVLAB, %white, RGB(50,20,150)
   Control Add TextBox, hDlg, %TXTVELOCITY, "",40,230,30,12
   Control Add Label, hDlg, %LABMSG, "",125,235,164,10, %ss_sunken
   Control Add Label, hDlg, %LABWIND, "WIND SPEED",155,225,52,10
   Control Set Color hDlg, %LABWIND, %white, RGB(50,20,150)
   Control Add Button, hDlg, %idok,"&Fire", 80, 232, 40, 14
   Control Add Button, hDlg, %BUTRESTART, "ReStart", 280, 232, 40, 14
   Control Add Button, hDlg, %idcancel, "&Quit", 335, 232, 40, 14
   Dialog Show Modal hDlg Call DlgCallBack
End Function
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
Sub InitGround(ByVal iTurn As Long)   'setup random ground layout and other vars
   Local iTemp       As Long
   Local iTemp2      As Long
   Local D1          As Long
   Local D2          As Long
   Local iSteps      As Long
   Local iArch       As Long
   Local iCounter    As Long
   ReDim gGround(1:400)
   If iTurn = 1 Then
      Control Set Text hDlg, %LABMSG, "Left castle's turn"
   Else
      Control Set Text hDlg, %LABMSG, "Right castle's turn"
   End If
   Control Enable hDlg, %idok
   gX1 = 50 + Rnd(1,51) 'gX1=castel1
   gX2 = 280 + Rnd(1,51)'gX2=castel2
   iTemp = 238 - Rnd(1,59)  'get random height for castle
   For iCounter = 1 To gX1  'setup flat area by each castle
      gGround(iCounter) = iTemp
   Next I
   iTemp = 238 - Rnd(1,59)  'get random height for castle
   For iCounter = gX2 To 400  'setup flat area by each castle
      gGround(iCounter) = iTemp
   Next I
   iTemp = gX1 + Rnd(1,(gX2 - gX1 - 20 + 1)) + 10  'get random center x position between castles
   gGround(iTemp) = 50 + Rnd(1,101) 'setup mountain height
   iTemp2 = gGround(iTemp) / 2      'get middle of mountain height
   D1 = iTemp2 - gGround(gX1) / 2   'get half difference between castle height and mountain
   D2 = iTemp2 - gGround(gX2) / 2   'get half difference between castle height and mountain
   iArch = 180
   iSteps = 180 / (iTemp - gX1 + 1)      'calc steps
   iTemp2 = gGround(gX1) + D1
   For iCounter = gX1 + 1 To iTemp - 1   'setup from castle1's x postion to midway
      iArch = iArch - iSteps
      gGround(iCounter) = Cos(iArch * .0174533) * D1 + iTemp2
   Next iCounter
   iArch = 1
   iSteps = 180 / (gX2 - iTemp + 1)      'calc steps
   iTemp2 = gGround(gX2) + D2
   For iCounter = iTemp + 1 To gX2 -1    'setup from castle2's x postion to midway
      iArch = iArch + iSteps
      gGround(iCounter) = Cos(iArch * .0174533) * D2 + iTemp2
   Next iCounter
   gX1 = gX1 - Rnd(5,50) 'move castles away from mountain
   gX2 = gX2 + Rnd(5,50)
   gWind = Rnd(1,151) - 75   'setup wind speed and direction
   Control Set Text hDlg, %LABWIND, "WindSpeed " + Str$(gWind)
End Sub
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
Sub DrawGround(ByVal hDc As Long,ByVal xScale As Single, ByVal yScale As Single)
   Local pOld        As POINTAPI
   Local iCounter    As Long
   Local iCounter2   As Long
   Local hOldPen     As Long
   hOldPen = SelectObject(hDc, CreatePen(%PS_SOLID, Int(5 * yScale), %green))  'change to yellow pen for drawing
   Call MoveToEx (hDc, 0, (gGround(1) * yScale), pOld)
   For iCounter = 1 To 400  'draw ground
      Call LineTo   (hDc, (iCounter * xScale), (gGround(iCounter) * yScale))
   Next iCounter
   DeleteObject SelectObject(hDC, CreatePen(%PS_SOLID, 1, %cyan))  'change to cyan pen to draw castle
   Call Rectangle (hDc, (gX1 -3) * xScale , ((gGround(gX1)- 8) * yScale), (gX1 + 3) * xScale, (gGround(gX1) * yScale))
   Call Rectangle (hDc, (gX1 -5) * xScale , ((gGround(gX1)- 10) * yScale), (gX1 - 2) * xScale, ((gGround(gX1)-8) * yScale))
   Call Rectangle (hDc, (gX1 +5) * xScale , ((gGround(gX1)- 10) * yScale), (gX1 + 2) * xScale, ((gGround(gX1)-8) * yScale))
   DeleteObject SelectObject(hDC, CreatePen(%PS_SOLID, 1, %red))  'change to red pen to draw castle
   Call Rectangle (hDc, (gX2 -3) * xScale , ((gGround(gX2)- 8) * yScale), (gX2 + 3) * xScale, (gGround(gX2) * yScale))
   Call Rectangle (hDc, (gX2 -5) * xScale , ((gGround(gX2)- 10) * yScale), (gX2 - 2) * xScale, ((gGround(gX2)-8) * yScale))
   Call Rectangle (hDc, (gX2 +5) * xScale , ((gGround(gX2)- 10) * yScale), (gX2 + 2) * xScale, ((gGround(gX2)-8) * yScale))
   DeleteObject SelectObject(hDC, CreatePen(%PS_SOLID, 1, %white))   'change pen
   Call MoveToEx (hDc, (200 - gWind) * xScale, (270 * yScale), pOld) 'move to draw wind
   Call LineTo   (hDc, (201 + gWind) * xScale, (270 * yScale))       'draw wind line
   If gWind < 0 Then 'neg
      Call MoveToEx (hDc, (200 + gWind) * xScale, (270 * yScale), pOld)
      Call LineTo   (hDc, (210 + gWind) * xScale, (265 * yScale))       'draw wind arrow
      Call LineTo   (hDc, (210 + gWind) * xScale, (270 * yScale))       'draw wind arrow
   Else 'positive arrow
      Call MoveToEx (hDc, (200 + gWind) * xScale, (270 * yScale), pOld)
      Call LineTo   (hDc, (190 + gWind) * xScale, (265 * yScale))       'draw wind arrow
      Call LineTo   (hDc, (190 + gWind) * xScale, (270 * yScale))       'draw wind arrow
   End If
   DeleteObject SelectObject(hDc, hOldPen)                  'return original pen
End Sub
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
Function Fire(ByVal hDc As Long, ByVal MyTurn As Long, ByVal Angle As Long, ByVal Velocity As Long, ByVal xScale As Single, ByVal yScale As Single, ByVal iSlow As Long) As Long
   Local pOld        As POINTAPI
   Local iCounter    As Long
   Local hOldPen     As Long
   Local V1          As Single
   Local V2          As Single
   Local xPos        As Long
   Local yPos        As Long
   If MyTurn = 1 Then
      yPos = gGround(gX1)
      xPos = gX1
      hOldPen = SelectObject(hDc, CreatePen(%PS_SOLID, 1, %cyan))  'change pen for drawing
   Else
      Angle = 180 - Angle
      yPos = gGround(gX2)
      xPos = gX2
      hOldPen = SelectObject(hDc, CreatePen(%PS_SOLID, 1, %red))  'change pen for drawing
   End If
   V1 = Cos(Angle * .0174533) * Velocity
   V2 = -Sin(Angle * .0174533) * Velocity
   Call MoveToEx(hDc, xPos * xScale, yPos * yScale, pOld)
      Do
         xPos = xPos + (V1 / 10)
         V1 = V1 + ((gWind - V1) / 30)
         yPos = yPos + (V2 / 10)
         V2 = V2 + 6
         Call LineTo(hDc, (xPos * xScale), (yPos * yScale))
         If iSlow Then Sleep 100
      Loop While xPos < 400 And yPos < gGround(xPos)
   DeleteObject SelectObject(hDC, CreatePen(%PS_SOLID, 1, %yellow))   'change pen in case someone wins
   If ((xPos < (gX2 + 7)) And (xPos > (gX2 - 5)) And MyTurn = 1) Or ((xPos < (gX1 + 5)) And (xPos > (gX1 - 7)) And MyTurn = 2) Then 'hit
      Call Ellipse(hDc, (xPos - 13) * xScale , ((yPos- 18) * yScale), (xPos + 13) * xScale, (yPos * yScale))
      Function = 1
   End If
   DeleteObject SelectObject(hDc, hOldPen)                  'return original pen
End Function
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
CallBack Function DlgCallBack()
   Select Case CbMsg
      Case %wm_initdialog
         Static xSize      As Long
         Static ySize      As Long
         Static xScale     As Single
         Static yScale     As Single
         Static iTurn      As Long     'keep track of whos turn
         Local iRet        As Long
         Local hDc         As Long
         Local ps          As PAINTSTRUCT
         Local iCounter    As Long
         Local iCounter2   As Long
         Local sText       As String
         Local iAngle      As Long
         Local iVelocity   As Long
         ReDim gShots(1:2)
         Randomize
         iTurn = 1         'start with player 1
         InitGround iTurn  'setup vars
         Dialog ReDraw hDlg
      Case %wm_size
         xScale = (LoWrd(CbLParam) / 400)
         yScale = (HiWrd(CbLParam) / 300)
         Dialog Get Size hDlg To xSize, ySize
         Control Set Loc hDlg, %idcancel, xSize - 60, ySize - 40     'move buttons
         Control Set Loc hDlg, %BUTRESTART, xSize - 110, ySize - 40        'move buttons
         Control Set Loc hDlg, %idok, 80, ySize - 40        'move buttons
         Control Set Loc hDlg, %TXTANGLE, 35, ySize - 41
         Control Set Loc hDlg, %TXTVELOCITY, 35, ySize - 30
         Control Set Loc hDlg, %IDALAB, 1, ySize - 41
         Control Set Loc hDlg, %IDVLAB, 1, ySize - 30
         Control Set Loc hDlg, %LABMSG, 125, ySize - 30
         iRet = GetDialogBaseUnits
         Control Set Loc hDlg, %LABWIND, ((220 * xScale) * 4) / LoWrd(iRet), ((300 * yScale) * 8) / HiWrd(iRet)
         Dialog ReDraw hDlg
      Case %wm_paint
         hDc = BeginPaint(hDlg, ps)                            'initiates window painting
            Call DrawGround(hDc, xScale, yScale)
            For iCounter = 1 To 2   'loop through players
               If Len(gShots(iCounter)) < 1 Then Iterate For
               For iCounter2 = 1 To ParseCount(gShots(iCounter)," ")     'loop through previous shots
                  Call Fire(hDc, iCounter, Val(Parse$(Parse$(gShots(iCounter)," ",iCounter2),"/",1)), Val(Parse$(Parse$(gShots(iCounter)," ",iCounter2),"/",2)), xScale, yScale, 0)
               Next iCounter2
            Next iCounter
         Call EndPaint(hDlg, ps)                                     'ends window painting
      Case %wm_destroy
      Case %wm_command
         Select Case CbCtl
            Case %BUTRESTART        'restart game
               Randomize
               InitGround iTurn     'setup vars
               ReDim gShots(1:2)    'wipe out prev shots
               Dialog ReDraw hDlg
            Case %idok  ' Fire!
               Control Get Text hDlg, %TXTANGLE To sText
               iAngle = Val(sText)
               Control Get Text hDlg, %TXTVELOCITY To sText
               iVelocity = Val(sText)
               gShots(iTurn) = Format$(iAngle) + "/" + Format$(iVelocity) + " " + gShots(iTurn) 'store previous shots
               If iVelocity = 0 Or iAngle = 0 Then Exit Select
               hDc = GetDC(hDlg)
                  iRet = Fire(hDc, iTurn, iAngle, iVelocity, xScale, yScale, 1)  'draw shot in slow motion
               Call ReleaseDC(hDlg, hDc)                                         'ends window painting
               Incr iTurn
               If iTurn > 2 Then iTurn = 1
               If iRet Then 'winner
                  Control Disable hDlg, %idok
                  Control Set Text hDlg, %LABMSG, "BOOOOOM!!!!   Game Over"
                  Beep:Beep:Beep
               Else        'no winner so setup for next player
                  If iTurn = 1 Then 'switch to next player
                     Control Set Text hDlg, %LABMSG, "Left castle's turn.  History=" + gShots(iTurn)
                  Else
                     Control Set Text hDlg, %LABMSG, "Right castle's turn. History=" + gShots(iTurn)
                  End If
                  If Len(gShots(iTurn)) > 1 Then
                     Control Set Text hDlg, %TXTANGLE, Parse$(Parse$(gShots(iTurn)," ",1),"/",1)
                     Control Set Text hDlg, %TXTVELOCITY, Parse$(Parse$(gShots(iTurn)," ",1),"/",2)
                  End If
               End If
               Dialog ReDraw hDlg
            Case %idcancel ' close dialog
               Dialog End CbHndl
         End Select  'WM_COMMAND
   End Select
End Function
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
